import express, {Application} from 'express';
import mongoose, {CallbackError} from "mongoose";

const MONGOOSE_STRING = process.env.MONGOOSE_STRING || 'mongodb://localhost:27017';

const app: Application = express();
const port: number = parseInt(process.env.SERVER_PORT || '8025');
const isDevelopment: boolean = process.env.NODE_ENV !== 'production';

mongoose.set("strictQuery", false);
mongoose.connect(MONGOOSE_STRING, (error: CallbackError) => {
    if (error) throw new Error(`Could not connect to database: ${error.message}`);
    console.log(`Successfully connected to the database @${MONGOOSE_STRING.split("://")[1].split("/")[0]}`);
    run();
});

const run = () =>
    app.listen(port, () => console.log(`LicenseAPI ${isDevelopment ? "development" : "production"} server started under port ${port}`));